/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest{}

// AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest struct for AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest
type AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest struct {
	Service *string             `json:"service,omitempty"`
	Data    *MysqlDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest instantiates a new AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest() *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest {
	this := AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest{}
	var service string = "mysql"
	this.Service = &service
	return &this
}

// NewAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequestWithDefaults instantiates a new AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequestWithDefaults() *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest {
	this := AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest{}
	var service string = "mysql"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) GetData() MysqlDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret MysqlDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) GetDataOk() (*MysqlDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given MysqlDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) SetData(v MysqlDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest struct {
	value *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest
	isSet bool
}

func (v NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) Get() *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest {
	return v.value
}

func (v *NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) Set(val *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest(val *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) *NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest {
	return &NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
